"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .chromedevtools import ChromeDevtools, ChromeDevtoolsTypedDict
from .cobaltstrike import CobaltStrike, CobaltStrikeTypedDict
from .elasticsearch import ElasticSearch, ElasticSearchTypedDict
from .fortigate import Fortigate, FortigateTypedDict
from .graphql import Graphql, GraphqlTypedDict
from .http import HTTP, HTTPTypedDict
from .ivantiavalanche import IvantiAvalanche, IvantiAvalancheTypedDict
from .kubernetes import Kubernetes, KubernetesTypedDict
from .ollama import Ollama, OllamaTypedDict
from .plexmediaserver import PlexMediaServer, PlexMediaServerTypedDict
from .pprof import Pprof, PprofTypedDict
from .prometheus import Prometheus, PrometheusTypedDict
from .prometheustarget import PrometheusTarget, PrometheusTargetTypedDict
from .redlionweb import RedlionWeb, RedlionWebTypedDict
from .scadaview import ScadaView, ScadaViewTypedDict
from censys_platform.types import BaseModel
from enum import Enum
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class TransportProtocol(str, Enum):
    UNKNOWN = ""
    TCP = "tcp"
    UDP = "udp"
    ICMP = "icmp"
    QUIC = "quic"


class EndpointScanStateTypedDict(TypedDict):
    banner: NotRequired[str]
    banner_hash_sha256: NotRequired[str]
    chrome_devtools: NotRequired[ChromeDevtoolsTypedDict]
    cobalt_strike: NotRequired[CobaltStrikeTypedDict]
    elasticsearch: NotRequired[ElasticSearchTypedDict]
    endpoint_type: NotRequired[str]
    fortigate: NotRequired[FortigateTypedDict]
    graphql: NotRequired[GraphqlTypedDict]
    hostname: NotRequired[str]
    http: NotRequired[HTTPTypedDict]
    ip: NotRequired[str]
    ivanti_avalanche: NotRequired[IvantiAvalancheTypedDict]
    kubernetes: NotRequired[KubernetesTypedDict]
    ollama: NotRequired[OllamaTypedDict]
    path: NotRequired[str]
    plex_media_server: NotRequired[PlexMediaServerTypedDict]
    port: NotRequired[int]
    pprof: NotRequired[PprofTypedDict]
    prometheus: NotRequired[PrometheusTypedDict]
    prometheus_target: NotRequired[PrometheusTargetTypedDict]
    redlion_web: NotRequired[RedlionWebTypedDict]
    scada_view: NotRequired[ScadaViewTypedDict]
    scan_time: NotRequired[str]
    transport_protocol: NotRequired[TransportProtocol]


class EndpointScanState(BaseModel):
    banner: Optional[str] = None

    banner_hash_sha256: Optional[str] = None

    chrome_devtools: Optional[ChromeDevtools] = None

    cobalt_strike: Optional[CobaltStrike] = None

    elasticsearch: Optional[ElasticSearch] = None

    endpoint_type: Optional[str] = None

    fortigate: Optional[Fortigate] = None

    graphql: Optional[Graphql] = None

    hostname: Optional[str] = None

    http: Optional[HTTP] = None

    ip: Optional[str] = None

    ivanti_avalanche: Optional[IvantiAvalanche] = None

    kubernetes: Optional[Kubernetes] = None

    ollama: Optional[Ollama] = None

    path: Optional[str] = None

    plex_media_server: Optional[PlexMediaServer] = None

    port: Optional[int] = None

    pprof: Optional[Pprof] = None

    prometheus: Optional[Prometheus] = None

    prometheus_target: Optional[PrometheusTarget] = None

    redlion_web: Optional[RedlionWeb] = None

    scada_view: Optional[ScadaView] = None

    scan_time: Optional[str] = None

    transport_protocol: Optional[TransportProtocol] = None
